# -*- coding: utf-8 -*-
"""signalBode.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/13L4DpLxLZkec9KkARAp3eUrts6QQQi83

Design a 15th-order bandpass filter in SOS format
"""

from scipy import signal
import numpy as np
import matplotlib.pyplot as plt

# Declaração das Variáveis
k = 1
w = 40
# Mostra a Função de transferência
print ("",k*w)
print ("----")
print (" s + ",w)
 
s1 = signal.lti( [w*k], [1,w])       # Função de Transferência
#s1 = signal.ZerosPolesGain( [1], [w],k)       # Função de Transferência
print(s1)
w, mag, phase = signal.bode(s1)
#print(s1.poles)
#print(s1.to_zpk)
#signal.dcgain(s1)
print(s1.to_tf)
#signal.ZerosPolesGain([1, 2], [3, 4], 5, dt=0.1)

# Começa a montar o primeiro gráfico
plt.figure()
plt.semilogx(w, mag)                    # Bode magnitude plot
 
plt.title('Magnitude')                  # Titulo
plt.xlabel('Frequência [rad/s]')        # Plota o label X
plt.ylabel('Amplitude [dB]')            # Plota o label Y
plt.grid(which='both', axis='both')     # Gride para frequências intermediárias
plt.grid(True)                          # Mostra o Grid
plt.margins(0, 0.1)                     # Deixa uma margem

# Começa a montar o segundo gráfico
plt.figure()
plt.semilogx(w, phase)                  # Bode phase plot
 
plt.title('Fase')                       # Titulo
plt.xlabel('Frequência [rad/s]')        # Plota o label X
plt.ylabel('Ângulo [º]')                # Plota o label Y
plt.grid(which='both', axis='both')     # Gride para frequências intermediárias
plt.grid(True)                          # Mostra o Grid
plt.margins(0, 0.1)                     # Deixa uma margem

plt.show()                              # Exibe os gráficos criados